clear;
close('all');
fclose('all');

read_parameters_Stratus; %Reading parameter files flux conf from D:/data/lb/flux_eval_rhb_06
plotit=1;
prtit=1;
if ~exist('ddd','var'); ddd=input('Input yearday to evaluate.... '); end;

%R=input('Confirm parameters and continue (yes/no) ?......','s');
R='yes';
if strcmp(lower(R(1)),'y')

    read_pc_day_Stratus_07a;
    read_son_day_Stratus_07a;
 %   read_motion_Stratus_07; % works, Commented for debugging because it is slow.
    read_hed_day_stratus_07a;
    read_gps_day_Stratus_07a;
    read_co2_Stratus_07a;
    read_scs_day_Stratus_07a;
holf=1;
if holf
    timatch_5_Stratus_07a;    
    timatch_30_Stratus_07a;  

    if backup=='1'
        backup_to_harddisk_rhb;
    end;
    
    jjx=min(length(latm),length(qvais));
    rlclr=(.52+.13/60*abs(latm(1:jjx))+(.082-.03/60*abs(latm(1:jjx))).*sqrt(qvais(1:jjx))).*(5.67e-8*(Tvais(1:jjx)'+273.15).^4); 
    
    clear jdy;
    latd=nanmean(latm)';
    lond=nanmean(lonm)';
    qa=qvais;
    iv=ones(length(qa),1)*NaN';
    jdys=jd_pc';
    jdy=jdys ;
    epic01_Rsclear_5x;

    
figure;plot(jd_pc,Rhvais,'.b',jd_scs,rhm,'.g');xlim([ddd ddd+1])
title(['Relative Humidity in %. ', cruise, year]);
xlabel(['Year Day', year]);
legend('PSD', 'Ship');
    print('-djpeg90 ',[way_images_flux '\RH_' num2str(ddd) '.jpg']);xlim([ddd ddd+1])
    
figure;plot(jd_pc,Tsea,'b',jd_scs,tsgm,'.g');xlim([ddd ddd+1])
title(['Sea Temperature (C). ', cruise, year]);   
xlabel(['Year Day', year]);     
legend('PSD', 'Ship');
    print('-djpeg90 ',[way_images_flux '\SST_' num2str(ddd) '.jpg']);xlim([ddd ddd+1])
    
figure;plot(jd_pc,Tvais,'b',jd_scs,tam,'.g');xlim([ddd ddd+1])
title(['Air Temperature (C). ', cruise, year]);   
xlabel(['Year Day', year]);   
legend('PSD','Ship');
    print('-djpeg90 ',[way_images_flux '\Tair_' num2str(ddd) '.jpg']);xlim([ddd ddd+1])

ii=find(~isnan(rlclr));
figure;plot(jd_pc,pirm,'b',jd_scs,irm,'g',jd_scs(ii),rlclr(ii),'r');xlim([ddd ddd+1])
title(['IR Flux (W/m^2). ', cruise, year]);    
xlabel(['Year Day', year]);    
legend('PSD', 'Ship', 'Clearsky');
    print('-djpeg90 ',[way_images_flux '\IRflux_' num2str(ddd) '.jpg']);xlim([ddd ddd+1])

ii=find(~isnan(Rscl));
figure;plot(jd_pc,pspm,'.b',jd_scs,solarm,'.g',jd_pc(ii),Rscl(ii),'r');xlim([ddd ddd+1])
title(['Solar Flux (W/m^2). ', cruise, year]);     
xlabel(['Time of day (', year, ')']);     
legend('PSD', 'Ship','Clearsky');
    print('-djpeg90 ',[way_images_flux '\SOLflux_' num2str(ddd) '.jpg']);xlim([ddd ddd+1])

hf5_append_stratus_07a;
hf30_append_stratus_07a;
%close all;

 %  ftp_to_NOAA2; %send data to our server    

    disp('  ');
    disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%');
    disp('<<<<<<<<         END of Flux_eval_program       >>>>>>>>>>>>>>>>>>>>>>>');
    disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%');


else   
    disp(['Go into the file ' fnpar ' to change the parameters']);
end;

end;